<?php
global $wpdb;
define('XEROOM_VERSION', '1.5.1');
define('XEROOM_HTTP_PATH', plugin_dir_url(__FILE__));
define('XEROOM_ROOT_PATH', plugin_dir_path(__FILE__));
define('XEROOM_CSS_PATH', XEROOM_HTTP_PATH.'css/');
define('XEROOM_JS_PATH', XEROOM_HTTP_PATH.'js/');
define('XEROOM_IMAGE_PATH', XEROOM_HTTP_PATH.'images/');
function xeroom_menu_icon_under_admin() {	
	add_menu_page('Add Xero API', 'Xeroom','manage_options', 'add_xero_api_fields', 'xeroom_api_setting', XEROOM_IMAGE_PATH.'xeroom_admin_menu_icon.png', 71); 
}	
function xeroom_api_setting(){ 
	require_once(XEROOM_ROOT_PATH.'library/xeroom_api_setting.php'); 
}	
function xeroom_master_install(){
	global $wpdb;
	require_once( ABSPATH . 'wp-admin/includes/upgrade.php');
	$xeroDebugTable  = $wpdb->prefix . 'xeroom_debug';
	$xeroTaxTable    = $wpdb->prefix . 'xeroom_tax';
	$xeroTable       = $wpdb->prefix . 'xeroom_credentials';
	$licenseTable    = $wpdb->prefix . 'xeroom_license_key_status';
	$query 			 = "SELECT count(*) as tblExist FROM information_schema.TABLES WHERE (TABLE_SCHEMA = '".DB_NAME."') AND (TABLE_NAME = '".$xeroTable."')";
	$getTableCount 	 = $wpdb->get_results($query);
	$CreateTabele 	 = $getTableCount[0]->tblExist;
	if($CreateTabele == 0){
		$wpdb->query("DROP TABLE IF EXISTS $xeroDebugTable");
		$wpdb->query("DROP TABLE IF EXISTS $xeroTaxTable");
		$wpdb->query("DROP TABLE IF EXISTS $xeroTable");
		$wpdb->query("DROP TABLE IF EXISTS $licenseTable");
		$xeroDebugQuery	 = "CREATE TABLE IF NOT EXISTS $xeroDebugTable(
							`id` int(11) NOT NULL AUTO_INCREMENT,
							`order_id` int(11) NOT NULL,
							`debug` text NOT NULL,
							`created_date` datetime NOT NULL,
							PRIMARY KEY (`id`)
							)";
		dbDelta($xeroDebugQuery);
		$xeroTaxQuery	 = "CREATE TABLE IF NOT EXISTS $xeroTaxTable(
							  `id` int(11) NOT NULL AUTO_INCREMENT,
							  `tax_name` varchar(255) NOT NULL,
							  `tax_rate` varchar(255) NOT NULL,
							  `tax_type` varchar(255) NOT NULL,
							  PRIMARY KEY (`id`)
							)";
		dbDelta($xeroTaxQuery);
		$xeroQuery	    = "CREATE TABLE IF NOT EXISTS $xeroTable (
						`id` int(11) NOT NULL AUTO_INCREMENT,
						`xero_api_key` varchar(255) NOT NULL,
						`xero_api_secret` varchar(255) NOT NULL,
						`sales_account` varchar(255) NOT NULL,
						`bank_code` varchar(255) NOT NULL,
						`tax_code` varchar(255) NOT NULL,
						`asset_code` varchar(255) NOT NULL,
						`sold_code` varchar(255) NOT NULL,
						`stock_master` varchar(255) NOT NULL,
						`product_master` varchar(255) NOT NULL,
						`payment_master` varchar(255) NOT NULL,
						 PRIMARY KEY (`id`)
						)";
		dbDelta($xeroQuery);
		$licenseQuery	= "CREATE TABLE IF NOT EXISTS $licenseTable (
						  `id` int(11) NOT NULL AUTO_INCREMENT,
						  `license_key` varchar(255) NOT NULL,
						  `status` varchar(255) NOT NULL,
						  `xero_method` varchar(255) NOT NULL,
							PRIMARY KEY (`id`)
						)";
		dbDelta($licenseQuery);
		$wpdb->insert($xeroTable, 
			array(
				'xero_api_key'		=>	"",
				'xero_api_secret'	=>	"",
				'sales_account'		=>	200,
				'bank_code'			=>	100,
				'tax_code'			=>	'20% (VAT on Income)',
				'asset_code'		=>	'630',
				'sold_code'			=>	'310',
				'stock_master'		=>	'w',
				'product_master'	=>	'w',
				'payment_master'	=>	'n'
			)
		);
		$wpdb->insert($licenseTable, 
			array(
				'license_key'		=>	'123456789',
				'status'			=>	"deactive",
				'xero_method'		=>	"trail"
			)
		);
	}
}
function xeroom_sendWooInvoiceToXero($order_id){	
	global $wpdb;
	global $product;
	global $order;
	$oId 				= 	intval($order_id); 
	$order 				= 	new WC_Order($oId); 
	$country 			= 	new WC_Countries(); 
	$orderTax			= 	new WC_Tax(); 
	
	//define Tables
	$xeroDebugTable  	= 	$wpdb->prefix . 'xeroom_debug';
	$xeroLicActive		=   $wpdb->prefix . "xeroom_license_key_status";
	$taxTableName		= 	$wpdb->prefix."xeroom_tax";
	$xeroTime          	= 	date('Y-m-d H:i:s');
	
	//License Key
	$sql				= 	"SELECT * FROM ".$xeroLicActive." WHERE id=1";
	$xeroLicensekeyAct	= 	$wpdb->get_results($sql);
	$active    			=	sanitize_text_field($xeroLicensekeyAct[0]->status);
	$lic_key    		=	sanitize_text_field($xeroLicensekeyAct[0]->license_key);
	$lic_method    		=	sanitize_text_field($xeroLicensekeyAct[0]->xero_method);
	//Check License of plugin
	if($active == 'active'){
		$url 			= "http://www.xeroom.com/apidata.php?license_key=".$lic_key;
		$result 		= wp_remote_fopen(esc_url($url));
		$validLicense	= json_decode($result, true);
	if(isset($validLicense[0]['lic_status']) &&  $validLicense[0]['lic_status'] == 'active'){	
		//Items Details
		$totalItems			= $order->get_item_count();
		$orderCurency		= $order->get_order_currency();
		$usedCupons			= "Coupon used ".implode(", ", $order->get_used_coupons());
		$shippingPrice		= $order->get_total_shipping();
		$totalDiscount		= $order->get_total_discount();
	
		// User Address
		$shipAddress		= $order->get_address();
		$allCountry			= $country->get_countries();
		$countryFullName	= $allCountry[$shipAddress['country']];
		$allState			= $country->get_states($shipAddress['country']);
		$stateFullName		= $allState[$shipAddress['state']];
		
		// Tax Rate Used
		$getTaxRate			= array( 
								'country'   => $shipAddress['country'],
								'state'     => $shipAddress['state'],
								'city'      => $shipAddress['city'],
								'postcode'  => $shipAddress['postcode'],
								'tax_class' => ''
							);
		$taxRatePercent		= $orderTax->find_rates($getTaxRate);
		if(count($taxRatePercent) !=0){
			foreach($taxRatePercent as $taxKey => $taxValue){
				$taxValue		= $taxValue;
			}
			$taxOnWholeCart		= $taxValue;
		}else{
			$taxOnWholeCart		= array();
		}
		
		// Xero Connectivity Api Credentials------------
		$query 				= "SELECT *  FROM `". $wpdb->prefix . "xeroom_credentials` WHERE `id`=1";
		$getApiCredentials 	= $wpdb->get_results($query);
		$xeroApiKey			= sanitize_text_field($getApiCredentials[0]->xero_api_key);
		$xeroApiSecret		= sanitize_text_field($getApiCredentials[0]->xero_api_secret);
		$salesAccount		= intval($getApiCredentials[0]->sales_account);
		$BankCode		  	= intval($getApiCredentials[0]->bank_code);
		$TaxCode		  	= sanitize_text_field($getApiCredentials[0]->tax_code);
		$AssetCode		  	= intval($getApiCredentials[0]->asset_code);
		$SoldCode		  	= intval($getApiCredentials[0]->sold_code);
		$StockMaster	  	= sanitize_text_field($getApiCredentials[0]->stock_master);
		$productMaster	  	= sanitize_text_field($getApiCredentials[0]->product_master);
		include_once(XEROOM_ROOT_PATH."library/xeroom_indexManager.php");
		define('BASE_PATH',dirname(__FILE__));
		define('XERO_KEY',$xeroApiKey);
		define('XERO_SECRET',$xeroApiSecret);
		define('PUBLIC_KEY', BASE_PATH . '/library/certs/publickey.cer');
		define('PRIVATE_KEY', BASE_PATH . '/library/certs/privatekey.pem');
		define('FORMAT', 'json');
		$xero        = new Xero(XERO_KEY, XERO_SECRET, PUBLIC_KEY, PRIVATE_KEY, FORMAT);
		// Xero Connectivity Api Credentials------------
		$ordersList  = $order->get_items();
		$orderDetails= array();
		$oKeyValue   = array();
		$countOrder  = 0;
		
		foreach($ordersList as $singleorderskey => $singleorders){
			$orderDetails[$countOrder]['name']			= $singleorders['name'];
			$orderDetails[$countOrder]['_product_id']	= $singleorders['product_id'];
			$orderDetails[$countOrder]['_variation_id']	= $singleorders['variation_id'];
			$orderDetails[$countOrder]['_qty']			= $singleorders['quantity'];
			$countOrder++;
		}
		$oderList 			= array();
		$uniqueTax     		= "";
		// Create new tax here
		if(count($taxOnWholeCart) !=0){
			$getAllTax			= $xero->TaxRates();
			$taxRate 			= $taxOnWholeCart['rate'];
			foreach($getAllTax['TaxRates']['TaxRate'] as $allTaxesNow){
				if($allTaxesNow['Name'] == $TaxCode){
					$uniqueTax 		= $allTaxesNow['TaxType']; 
					$displayTaxRate = $allTaxesNow['DisplayTaxRate']; 
					break;
				}
			}
			if($uniqueTax == ""){
				foreach($getAllTax['TaxRates']['TaxRate'] as $allTaxesNow){
					if($allTaxesNow['TaxComponents']['TaxComponent']['Rate'] == $taxRate){
						$uniqueTax 		= $allTaxesNow['TaxType']; 
						$displayTaxRate = $allTaxesNow['DisplayTaxRate']; 
						break;
					}
				}
			}
			if($uniqueTax == ""){
				$taxName		= "Default Xeroom Sales Tax";
				$query   		= "SELECT * FROM `".$taxTableName."` WHERE `tax_rate` ='".$taxRate."'";
				$getTaxRates   	= $wpdb->get_results($query);
				if(count($getTaxRates) > 0){
					$uniqueTax 	=	$getTaxRates[0]->tax_type;
				}else{
					$xero_rate 	=array(
						"TaxRate"		=> 	array(
							"Name"					=> "$taxName",
							"ReportTaxType"			=> 'OUTPUT',
							"TaxComponents"			=> array(
								"TaxComponent"		=> array(
									"Name"      	=> "VAT",
									"Rate"      	=> $taxRate
								)
							)	
						)
					);
					$taxResult 	= $xero->TaxRates($xero_rate);
					if(isset($taxResult['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$taxResult['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, 
							array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errD),
								'created_date' 			=> $xeroTime
							)
						);
					}else if(isset($taxResult['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD=$taxResult['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($er=0; $er<count($errD); $er++){
							$errorMessage	=	$taxResult['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$er]['Message'];
							$wpdb->insert($xeroDebugTable, 
								array(
									'order_id'  			=> intval($order_id),
									'debug'   				=> sanitize_text_field($errorMessage),
									'created_date' 			=> $xeroTime
								)
							);
						}
					}else if($taxResult['Status'] == "OK"){
						$uniqueTax  = $taxResult['TaxRates']['TaxRate']['TaxType'];
						$wpdb->insert($taxTableName, 
							array(
								'tax_name'		=>	sanitize_text_field($taxResult['TaxRates']['TaxRate']['Name']),
								'tax_rate'	    =>	sanitize_text_field($taxRate),
								'tax_type'		=>	sanitize_text_field($taxResult['TaxRates']['TaxRate']['TaxType'])
							)
						);
					}else{
						$wpdb->insert($xeroDebugTable, 
							array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($taxResult),
								'created_date' 			=> $xeroTime
							)
						);
					}
				}
			}
		} 
		// End Create new tax here
		for($i=0; $i<count($orderDetails); $i++){
			$productAttributes		= get_post_meta($orderDetails[$i]['_product_id'], '_product_attributes');
			$allProductAttr			= "";
			if($productAttributes){
				foreach($productAttributes[0] as $key => $value){
					if(isset($orderDetails[$i][$key]) && $orderDetails[$i][$key] !=""){
						$attributeName   = get_taxonomy($value['name']);
						$attributeName   = $attributeName->labels->name;
						$slugValue 		 = get_term_by('slug', $orderDetails[$i][$key], $value['name']);
						$allProductAttr	.= ', '.$attributeName.': '.$slugValue->name;
					}
				}
			}
			if(isset($orderDetails[$i]['_variation_id']) && $orderDetails[$i]['_variation_id'] !=0){
				$unitPrice			= get_post_meta($orderDetails[$i]['_variation_id']);
				$itemId				= $orderDetails[$i]['_variation_id'];
				$product            = new WC_Product_Variation($orderDetails[$i]['_variation_id']);
			}else{
				$unitPrice          = get_post_meta($orderDetails[$i]['_product_id']);	
				$itemId				= $orderDetails[$i]['_product_id'];
				$product            = new WC_Product($orderDetails[$i]['_product_id']);
			}
			if($unitPrice['_sku'][0] !=""){
				$sku 	  		 =  $unitPrice['_sku'][0];
			}else{
				$sku 	  		 =  $orderDetails[$i]['_product_id'];
			}
			if($unitPrice['_sale_price'][0] !=""){
				$unitPriceNow 	  		 =  $unitPrice['_sale_price'][0];
				if($allProductAttr == "")
					$allProductAttr	= ', Full Price: '.$unitPrice['_regular_price'][0];
				else
					$allProductAttr	.= ', Full Price: '.$unitPrice['_regular_price'][0];
			}else{
				$unitPriceNow 	  		 =  $unitPrice['_regular_price'][0];
			}
			
			$unitPriceNow				= 	$product->get_price_excluding_tax();
			$unitPriceNow				= 	number_format((float)$unitPriceNow, 2, '.', ''); 
			if($allProductAttr !=""){
				$descriptionName		 =  $orderDetails[$i]['name'].$allProductAttr;
				if($productMaster == "w")
					$oderList[$i]['Description']  =  $orderDetails[$i]['name'].$allProductAttr;
			}else{
				$descriptionName		 =  $orderDetails[$i]['name'];
				if($productMaster == "w")
					$oderList[$i]['Description']  =  $orderDetails[$i]['name'];
			}
		
			$oderList[$i]['Quantity']    	  =  $orderDetails[$i]['_qty'];
			if($productMaster == "w" || $productMaster == "n")
			$oderList[$i]['UnitAmount']  	  =  $unitPriceNow;
			$oderList[$i]['ItemCode']    	  =  $sku;
			$oderList[$i]['DiscountRate']	  =  0;
			if($uniqueTax != "")
			$oderList[$i]['TaxType']	      =  $uniqueTax;
			$oderList[$i]['AccountCode'] 	  =  $salesAccount;
			$post_details 				 	  =  get_post($orderDetails[$i]['_product_id']);
			$xItemName					      =  substr($post_details->post_title,0,48);
			if($xItemName ==""){ $xItemName = "No Name_".rand(); }
			$xItemDesc					      =  $post_details->post_content;
			$xItemStock					      =  $unitPrice['_stock'][0];
			/* Stock Master */
			if($StockMaster == "w"){
				if($xItemStock == 0 ||  $xItemStock == ""){
					$checkwithoutStock	= $xero->Items($sku);
					if(isset($checkwithoutStock['Items']['Item']['QuantityOnHand'])){
						$addNewQuant = $orderDetails[$i]['_qty'];
						$increaseItems   						=  array(    
							"Invoice"     						=> array(
								"Type"   						=> "ACCPAY",
								"Contact"  						=> array(
									"Name"  					=> "Inventory Adjustments"
								),
								"Date"							=> date('Y-m-d'),
								"DueDate"						=> date('Y-m-d'),
								"LineAmountTypes"				=> "NoTax",
								"Status"						=> "AUTHORISED",
								"LineItems"  					=> array(
									"LineItem"  				=> array(
										"ItemCode"  			=> $sku,
										"Description"  			=> $descriptionName,
										"Quantity"  			=> $addNewQuant,
										"UnitAmount"  			=> $unitPriceNow,
										"AccountCode"  			=> $AssetCode,
									)
								)
							)
						);
						$increaseWithoutStocktest  = $xero->Invoices($increaseItems);	
						if(isset($increaseWithoutStocktest['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
							$errD=$increaseWithoutStocktest['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errD),
								'created_date' 			=> $xeroTime						
							));				
						}else if(isset($increaseWithoutStocktest['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
							$errD	=	array();
							$errD	=	$increaseWithoutStocktest['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
							for($e=0; $e<count($errD); $e++){
								$errorMessage	=	$increaseWithoutStocktest['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
								$wpdb->insert($xeroDebugTable, array(
									'order_id'  			=> intval($order_id),
									'debug'   				=> sanitize_text_field($errorMessage),
									'created_date' 			=> $xeroTime
								));					
							}				
						}
					}else{
						$createItemWithoutStock					=array(
							"Item"								=>array(
								"Code"							=>$sku,
								"Name"							=>$xItemName,
								"Description"					=>$descriptionName),
								"SalesDetails"					=>array(
									"UnitPrice"					=>$unitPriceNow,
									"AccountCode"				=>$salesAccount
								),
								"PurchaseDetails" 				=>array(
									"UnitPrice"					=>$unitPriceNow,
									"COGSAccountCode"			=>$SoldCode
								)
						);
						$withoutStockXero  =  $xero->Items($createItemWithoutStock);
						if(isset($withoutStockXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){							
							$errD=$withoutStockXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];					
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),							
								'debug'   				=> sanitize_text_field($errD),
								'created_date' 			=> $xeroTime						
							));				
						}else if(isset($withoutStockXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
							$errD	=	array();
							$errD	=	$withoutStockXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
							for($e=0; $e<count($errD); $e++){
								$errorMessage  = $withoutStockXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
								$wpdb->insert($xeroDebugTable, array(
									'order_id'  			=> intval($order_id),
									'debug'   				=> sanitize_text_field($errorMessage),
									'created_date' 			=> $xeroTime
								));					
							}				
						}
						$oderList[$i]['Description']	= $descriptionName;
						$oderList[$i]['UnitAmount']		= $unitPriceNow;
					}
				}else {
					$newItemsCode						=array(
					"Item" 								=>array(
						"Code"							=>$sku,
						"Name"							=>$xItemName,
						"Description"					=>$descriptionName,
						"PurchaseDescription"			=>$xItemName,
						"IsTrackedAsInventory"			=>true,
						"IsSold"						=>true,
						"IsPurchased"					=>true,
						"InventoryAssetAccountCode"		=>$AssetCode,
						"QuantityOnHand"				=>$xItemStock,
						"TotalCostPool"					=>$xItemStock*$unitPriceNow,
						"InventoryAssetAccountCode"		=>$AssetCode,
						"SalesDetails"					=>array(
							"UnitPrice"					=>$unitPriceNow,
							"AccountCode"				=>$salesAccount
						),
						"PurchaseDetails" 				=>array(
							"UnitPrice"					=>$unitPriceNow,
							"COGSAccountCode"			=>$SoldCode
						)
					)
				);
				$createItem		= $xero->Items($newItemsCode);				
				if(isset($createItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){					
					$errD=$createItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];					
					$wpdb->insert($xeroDebugTable, array(
						'order_id'  			=> intval($order_id),							
						'debug'   				=> sanitize_text_field($errD),							
						'created_date' 			=> $xeroTime						
					));				
				}else if(isset($createItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
					$errD	=	array();
					$errD	=	$createItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
					for($e=0; $e<count($errD); $e++){
						$errorMessage	=	$createItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errorMessage),
							'created_date' 			=> $xeroTime
						));					
					}				
				}
				$itemsDetails  	= $createItem['Items']['Item'];
				$itemCode		= $itemsDetails['Code'];
				$itemQuantity	= $itemsDetails['QuantityOnHand'];
				$itemAction		= "";
				if($itemQuantity > $xItemStock){
					$newQuantity = $itemQuantity - $xItemStock;
					$itemAction  = "decrease";
				}else if($itemQuantity < $xItemStock){
					$newQuantity = $xItemStock - $itemQuantity;
					$itemAction  = "increase";
				}
				if($itemAction  == "decrease"){
					$decreaseItems	= array(
						"CreditNote"						=> array(
							"Type"							=> "ACCPAYCREDIT",
							"Contact"  						=> array(
								"Name"  					=> "Inventory Adjustments"
							),
							"Date"							=> date('Y-m-d'),
							"DueDate"						=> date('Y-m-d'),
							"LineAmountTypes"				=> "NoTax",
							"Status"						=> "AUTHORISED",
							"LineItems"  					=> array(
								"LineItem"  				=> array(
									"ItemCode"  			=> $sku,
									"Description"  			=> $descriptionName,
									"Quantity"  			=> $newQuantity,
									"UnitAmount"  			=> $unitPriceNow,
									"AccountCode"  			=> $AssetCode,
								)
							)
						)
					);
					$decItemXero  =  $xero->creditnotes($decreaseItems);
					if(isset($decItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$decItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errD),							
							'created_date' 			=> $xeroTime						
						));				
					}else if(isset($decItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD	=	array();
						$errD	=	$decItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($e=0; $e<count($errD); $e++){
							$errorMessage	=	$decItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errorMessage),
								'created_date' 			=> $xeroTime
							));					
						}				
					}					
				}
				if($itemAction  == "increase"){
					$increaseItems   						=  array(    
						"Invoice"     						=> array(
							"Type"   						=> "ACCPAY",
							"Contact"  						=> array(
								"Name"  					=> "Inventory Adjustments"
							),
							"Date"							=> date('Y-m-d'),
							"DueDate"						=> date('Y-m-d'),
							"LineAmountTypes"				=> "NoTax",
							"Status"						=> "AUTHORISED",
							"LineItems"  					=> array(
								"LineItem"  				=> array(
									"ItemCode"  			=> $sku,
									"Description"  			=> $descriptionName,
									"Quantity"  			=> $newQuantity,
									"UnitAmount"  			=> $unitPriceNow,
									"AccountCode"  			=> $AssetCode,
								)
							)
						)
					);
					$incrItemXero  = $xero->Invoices($increaseItems);					
					if(isset($incrItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$incrItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errD),
							'created_date' 			=> $xeroTime						
						));				
					}else if(isset($incrItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD	=	array();
						$errD	=	$incrItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($e=0; $e<count($errD); $e++){
							$errorMessage	=	$incrItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errorMessage),
								'created_date' 			=> $xeroTime
							));					
						}				
					}		
				}
				}
			}else if($StockMaster == "x"){
				$xeroInventryStock  = $xero->Items($sku);
				if(is_array($xeroInventryStock)){
					if(isset($xeroInventryStock['Items']['Item']['QuantityOnHand'])){
						$quantityI  = $xeroInventryStock['Items']['Item']['QuantityOnHand'];
						$orderPro	= new WC_Product($itemId); 
						$orderPro->set_stock($quantityI);
						if($productMaster == "x"){
							$oderList[$i]['Description']	= $xeroInventryStock['Items']['Item']['Description'];
							$oderList[$i]['UnitAmount']		= $xeroInventryStock['Items']['Item']['SalesDetails']['UnitPrice'];
						}
					}else{
						$simpleItemCode							=array(
							"Item"								=>array(
								"Code"							=>$sku,
								"Name"							=>$xItemName,
								"Description"					=>$descriptionName),
								"SalesDetails"					=>array(
									"UnitPrice"					=>$unitPriceNow,
									"AccountCode"				=>$salesAccount
								),
								"PurchaseDetails" 				=>array(
									"UnitPrice"					=>$unitPriceNow,
									"COGSAccountCode"			=>$SoldCode
								)
						);
						$simpleXeroItem  =  $xero->Items($simpleItemCode);					
						if(isset($simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
							$errD=$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errD),
								'created_date' 			=> $xeroTime						
							));				
						}else if(isset($simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
							$errD	=	array();
							$errD	=	$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
							for($e=0; $e<count($errD); $e++){
								$errorMessage	=	$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
								$wpdb->insert($xeroDebugTable, array(
									'order_id'  			=> intval($order_id),
									'debug'   				=> sanitize_text_field($errorMessage),
									'created_date' 			=> $xeroTime
									));					
							}				
						}	
						$oderList[$i]['Description']	= $descriptionName;
						$oderList[$i]['UnitAmount']		= $unitPriceNow;	
					}
				}else{
					$simpleItemCode							=array(
						"Item"								=>array(
							"Code"							=>$sku,
							"Name"							=>$xItemName,
							"Description"					=>$descriptionName),
							"SalesDetails"					=>array(
								"UnitPrice"					=>$unitPriceNow,
								"AccountCode"				=>$salesAccount
							),
							"PurchaseDetails" 				=>array(
								"UnitPrice"					=>$unitPriceNow,
								"COGSAccountCode"			=>$SoldCode
							)
					);
					$simpleXeroItem  =  $xero->Items($simpleItemCode);					
					if(isset($simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errD),
							'created_date' 			=> $xeroTime						
						));				
					}else if(isset($simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD	=	array();
						$errD	=	$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($e=0; $e<count($errD); $e++){
							$errorMessage	=	$simpleXeroItem['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errorMessage),
								'created_date' 			=> $xeroTime
								));					
						}				
					}	
					$oderList[$i]['Description']	= $descriptionName;
					$oderList[$i]['UnitAmount']		= $unitPriceNow;
				}
			}else { 
				$checkWoNoStoSimpleItem	= $xero->Items($sku);
				if(isset($checkWoNoStoSimpleItem['Items']['Item']['QuantityOnHand'])){
					$addNewQuant = $orderDetails[$i]['_qty'];
					$increaseItems   						=  array(    
						"Invoice"     						=> array(
							"Type"   						=> "ACCPAY",
							"Contact"  						=> array(
								"Name"  					=> "Inventory Adjustments"
							),
							"Date"							=> date('Y-m-d'),
							"DueDate"						=> date('Y-m-d'),
							"LineAmountTypes"				=> "NoTax",
							"Status"						=> "AUTHORISED",
							"LineItems"  					=> array(
								"LineItem"  				=> array(
									"ItemCode"  			=> $sku,
									"Description"  			=> $descriptionName,
									"Quantity"  			=> $addNewQuant,
									"UnitAmount"  			=> $unitPriceNow,
									"AccountCode"  			=> $AssetCode,
								)
							)
						)
					);
					$incrWoNoStockTraiItemXero  = $xero->Invoices($increaseItems);	
					if(isset($incrWoNoStockTraiItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$incrWoNoStockTraiItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errD),
							'created_date' 			=> $xeroTime						
						));				
					}else if(isset($incrWoNoStockTraiItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD	=	array();
						$errD	=	$incrWoNoStockTraiItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($e=0; $e<count($errD); $e++){
							$errorMessage	=	$incrTraiItemXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errorMessage),
								'created_date' 			=> $xeroTime
							));					
						}				
					}
				}else{
					$simpleItemsCode=array(
						"Item"								=>array(
							"Code"							=>$sku,
							"Name"							=>$xItemName,
							"Description"					=>$descriptionName),
							"SalesDetails"					=>array(
								"UnitPrice"					=>$unitPriceNow,
								"AccountCode"				=>$salesAccount
							),
							"PurchaseDetails" 				=>array(
								"UnitPrice"					=>$unitPriceNow,
								"COGSAccountCode"			=>$SoldCode
							)
					);
					$againSimpleXero  = $xero->Items($simpleItemsCode);				
					if(isset($againSimpleXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
						$errD=$againSimpleXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
						$wpdb->insert($xeroDebugTable, array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errD),						
							'created_date' 			=> $xeroTime						
						));				
					}else if(isset($againSimpleXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
						$errD	=	array();
						$errD	=	$againSimpleXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
						for($e=0; $e<count($errD); $e++){
							$errorMessage	=	$againSimpleXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
							$wpdb->insert($xeroDebugTable, array(
								'order_id'  			=> intval($order_id),
								'debug'   				=> sanitize_text_field($errorMessage),
								'created_date' 			=> $xeroTime
								));					
						}				
					}
				}
			} 
			if($shippingPrice != 0 || $shippingPrice !=""){
				$newItemsCodeShip	=	array(
					"Item"		=> array(
						"Code"      	=> "shipping_price",
						"Description"   => "Shipping Price"
					)
				);
				$xero->Items($newItemsCodeShip);
			}
			if($totalDiscount != 0){
				$newItemsCodeDis	=	array(
					"Item"		=> array(
						"Code"      	=> "discount_price",
						"Description"   => "Discount Price"
					)
				);
				$xero->Items($newItemsCodeDis);
			}
		} 
		if($shippingPrice != 0 || $shippingPrice !=""){
			$oderList[count($orderDetails)]['Description']  =  "Shipping Price";
			$oderList[count($orderDetails)]['Quantity']     =  1;
			$oderList[count($orderDetails)]['UnitAmount']   =  $shippingPrice;
			$oderList[count($orderDetails)]['DiscountRate'] =  0;
			$oderList[count($orderDetails)]['ItemCode']     =  "shipping_price";
			if($taxOnWholeCart['shipping'] == "yes"){
				if($uniqueTax != "")
				$oderList[count($orderDetails)]['TaxType']      =  $uniqueTax;
			}
			$oderList[count($orderDetails)]['AccountCode']      =  $salesAccount;
		}
		if($lic_method !="trail"){
			if($totalDiscount != 0){
				if($shippingPrice != 0 || $shippingPrice !=""){
					$nextCount	= count($orderDetails)+1;
				}else{
					$nextCount	= count($orderDetails);
				}
				$oderList[$nextCount]['Description']  =  $usedCupons;
				$oderList[$nextCount]['Quantity']     =  1;
				$oderList[$nextCount]['UnitAmount']   =  -$totalDiscount;
				$oderList[$nextCount]['DiscountRate'] =  0;
				$oderList[$nextCount]['ItemCode']     =  "discount_price";
				if($uniqueTax != "")
				$oderList[$nextCount]['TaxType']      =  $uniqueTax;
				$oderList[$nextCount]['AccountCode']  =  $salesAccount;
			}
		}
		for($i=0; $i<count($oderList); $i++){  
			$lineItemsArray[]  =  array("LineItem" => array($oderList[$i])); 
		}
		$currentDate 				 = date('Y-m-d H:i:s');
		if($lic_method !="trail"){
			$new_invoice = array( 
			array(
			"Type"=>"ACCREC",
			"Contact" => array(
				"Name" 			=> $shipAddress['first_name'].' '.$shipAddress['last_name'],
				"FirstName" 	=> $shipAddress['first_name'],
				"LastName " 	=> $shipAddress['last_name'],
				"EmailAddress" 	=> $shipAddress['email'],
				"Addresses" 	=> array(
					"Address"	=> array(
						array(
							"AddressType"   => base64_decode('UE9CT1g='),
							"AttentionTo"   => "",
							"AddressLine1"  => $shipAddress['company'],
							"AddressLine2"  => $shipAddress['address_1'],
							"AddressLine3"  => $shipAddress['address_2'],
							"City"     		=> $shipAddress['city'],
							"Region"    	=> $stateFullName,
							"Country"    	=> $countryFullName,
							"PostalCode"   	=> $shipAddress['postcode']
						)
					)
				),
				"Phones"      			=> array(
					"Phone" 			=> array(
						"PhoneType"     => base64_decode('TU9CSUxF'),
						"PhoneNumber"	=> $shipAddress['phone']
					)
				)
			),
			"Date" 						=> $currentDate,
			"DueDate" 					=> date('Y-m-d', strtotime('+3 day')),
			"ExpectedPaymentDate" 		=> date('Y-m-d', strtotime('+3 day')),
			"Status" 					=> base64_decode('QVVUSE9SSVNFRA=='),
			"CurrencyCode" 				=> $orderCurency,
			"LineAmountTypes" 			=> base64_decode('RXhjbHVzaXZl'),
			"Reference" 				=> $order_id,
			"LineItems"					=> $lineItemsArray)
			);
		}else{
			$new_invoice = array( 
			array(
			"Type"=>"ACCREC",
			"Contact" => array(
				"Name" 			=> $shipAddress['first_name'].' '.$shipAddress['last_name'],
				"FirstName" 	=> $shipAddress['first_name'],
				"LastName " 	=> $shipAddress['last_name'],
				"EmailAddress" 	=> $shipAddress['email'],
				"Addresses" 	=> array(
					"Address"	=> array(
						array(
							"AddressType"   => base64_decode('UE9CT1g='),
							"AttentionTo"   => "Created using demo version of Xeroom",
							"AddressLine1"  => "",
							"AddressLine2"  => "",
							"AddressLine3"  => "",
							"City"     		=> "",
							"Region"    	=> "",
							"Country"    	=> "",
							"PostalCode"   	=> ""
						)
					)
				),
				"Phones"      			=> array(
					"Phone" 			=> array(
						"PhoneType"     => base64_decode('TU9CSUxF'),
						"PhoneNumber"	=> $shipAddress['phone']
					)
				)
			),
			"Date" 						=> $currentDate,
			"DueDate" 					=> date('Y-m-d', strtotime('+3 day')),
			"ExpectedPaymentDate" 		=> date('Y-m-d', strtotime('+3 day')),
			"Status" 					=> base64_decode('QVVUSE9SSVNFRA=='),
			"CurrencyCode" 				=> $orderCurency,
			"LineAmountTypes" 			=> base64_decode('RXhjbHVzaXZl'),
			"Reference" 				=> $order_id,
			"LineItems"					=> $lineItemsArray)
			);
		}
		if(isset($validLicense[0]['lic_status']) && $validLicense[0]['lic_status'] == 'active'){
			$invoiceCreated		 = $xero->Invoices($new_invoice);
			if(isset($invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
				$errD=$invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'];
				$wpdb->insert($xeroDebugTable, 
					array(
						'order_id'  			=> intval($order_id),
						'debug'   			    => sanitize_text_field($errD),
						'created_date' 			=> $xeroTime
					)
				);
			}else if(isset($invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
				$errD	=	array();
				$errD	=	$invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
				for($e=0; $e<count($errD); $e++){
					$errorMessage	=	$invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
					$wpdb->insert($xeroDebugTable, 
						array(
							'order_id'  			=> intval($order_id),
							'debug'   				=> sanitize_text_field($errorMessage),
							'created_date' 			=> $xeroTime
						)
					);
				}
			}else if($invoiceCreated['Status'] !="OK"){
				$wpdb->insert($xeroDebugTable, 
					array(
						'order_id'  			=> intval($order_id),
						'debug'   				=> sanitize_text_field($invoiceCreated),
						'created_date' 			=> $xeroTime
					)
				);
			}
		}
		if($invoiceCreated['Status'] == "OK"){
			$InvoiceNumber			= $invoiceCreated['Invoices']['Invoice']['InvoiceNumber'];
			$InvoiceID			    = $invoiceCreated['Invoices']['Invoice']['InvoiceID'];
			$AmountDue				= $invoiceCreated['Invoices']['Invoice']['AmountDue'];
			$my_order_post = array(
				'ID'           				=> intval($order_id),
				'post_content'   			=> sanitize_text_field($InvoiceNumber),
				'post_content_filtered' 	=> sanitize_text_field($InvoiceID),
				'post_mime_type' 			=> sanitize_text_field($AmountDue)
			);
			wp_update_post($my_order_post);
		}
	}else{
		$wpdb->insert($xeroDebugTable, 
			array(
				'order_id'  			=> intval($order_id),
				'debug'   				=> sanitize_text_field("Your License is expire, Please contact xeroom support team."),
				'created_date' 			=> $xeroTime
			)
		);
	}
  }else{
	  $wpdb->insert($xeroDebugTable, 
			array(
				'order_id'  			=> intval($order_id),
				'debug'   				=> sanitize_text_field("Please use trail or premium license key to work xeroom plugin."),
				'created_date' 			=> $xeroTime
			)
		);
  }
}
function xeroom_paymentDoneOnCheckout($order_id){
	include_once(XEROOM_ROOT_PATH."library/xeroom_indexManager.php");
	global $wpdb;
	$xeroDebugTable  	= $wpdb->prefix . 'xeroom_debug';
	$xeroTime          	= date('Y-m-d H:i:s');
	$query 				= "SELECT *  FROM `". $wpdb->prefix . "xeroom_credentials` WHERE `id`=1";
	$getApiCredentials 	= $wpdb->get_results($query);
	$xeroApiKey			= sanitize_text_field($getApiCredentials[0]->xero_api_key);
	$xeroApiSecret		= sanitize_text_field($getApiCredentials[0]->xero_api_secret);
	$salesAccount		= intval($getApiCredentials[0]->sales_account);
	$BankCode		  	= intval($getApiCredentials[0]->bank_code);
	$sendOrNot		  	= $getApiCredentials[0]->payment_master;
	if($sendOrNot == "y"){
		define('BASE_PATH',dirname(__FILE__));
		define('XERO_KEY',$xeroApiKey);
		define('XERO_SECRET',$xeroApiSecret);
		define('PUBLIC_KEY', BASE_PATH . '/library/certs/publickey.cer');
		define('PRIVATE_KEY', BASE_PATH . '/library/certs/privatekey.pem');
		define('FORMAT', 'json');
		$sql 	= "SELECT * FROM `" . $wpdb->prefix . "xeroom_credentials` WHERE `id` = 1";
		$getAccounts 		= $wpdb->get_results($sql);
		$xero_timezone 		= new DateTimeZone('UTC');
		$xero_time			= date('Y-m-d H:i:s');
		$xero_date 			= new DateTime($xero_time,$xero_timezone);
		$BankCode 		    = intval($getAccounts[0]->bank_code);
		
		$xero        		= new Xero(XERO_KEY, XERO_SECRET, PUBLIC_KEY, PRIVATE_KEY, FORMAT);
		$order_details 		=  get_post($order_id);
		$new_payment = array( 
			array(
				"Invoice" 				=> array(
					"InvoiceNumber" 	=> $order_details->post_content
				),
				"Account" 				=> array(
					"Code" 				=> $BankCode
				),
				"Date" 					=> $xero_date,
				"Amount"				=> $order_details->post_mime_type
			)
		);
		$paymentXero  =  $xero->Payments($new_payment);
		if(isset($paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
			$errD=$paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'].". Please Create your bank account on xero and update bank code in xeroom setting's bank code.";
			$wpdb->insert($xeroDebugTable, 
				array(
					'order_id'  			=> intval($order_id),
					'debug'   				=> sanitize_text_field($errD),
					'created_date' 			=> $xeroTime
				)
			);
		}else if(isset($paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
			$errD	=	array();
			$errD	=	$invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
			for($e=0; $e<count($errD); $e++){
				$errorMessage	=	$paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
				$wpdb->insert($xeroDebugTable, 
					array(
						'order_id'  			=> intval($order_id),
						'debug'   				=> sanitize_text_field($errorMessage),
						'created_date' 			=> $xeroTime
					)
				);
			}
		}
	}
}
function xeroom_paymentDoneOnStatusCompleted($order_id){
	include_once(XEROOM_ROOT_PATH."library/xeroom_indexManager.php");
	global $wpdb;
	$xeroDebugTable  	= $wpdb->prefix . 'xeroom_debug';
	$xeroTime          	= date('Y-m-d H:i:s');
	$query 				= "SELECT *  FROM `". $wpdb->prefix . "xeroom_credentials` WHERE `id`=1";
	$getApiCredentials 	= $wpdb->get_results($query);
	$xeroApiKey			= sanitize_text_field($getApiCredentials[0]->xero_api_key);
	$xeroApiSecret		= sanitize_text_field($getApiCredentials[0]->xero_api_secret);
	$salesAccount		= intval($getApiCredentials[0]->sales_account);
	$BankCode		  	= intval($getApiCredentials[0]->bank_code);
	define('BASE_PATH',dirname(__FILE__));
	define('XERO_KEY',$xeroApiKey);
	define('XERO_SECRET',$xeroApiSecret);
	define('PUBLIC_KEY', BASE_PATH . '/library/certs/publickey.cer');
	define('PRIVATE_KEY', BASE_PATH . '/library/certs/privatekey.pem');
	define('FORMAT', 'json');
	$xero        = new Xero(XERO_KEY, XERO_SECRET, PUBLIC_KEY, PRIVATE_KEY, FORMAT);
	global $woocommerce; 
	$order 						= new WC_Order($order_id); 
	$order_details 				= get_post($order_id);
	$xero_timezone 				= new DateTimeZone('UTC');
	$xero_time					= date('Y-m-d H:i:s');
	$xero_date 					= new DateTime($xero_time,$xero_timezone);
	$new_payment = array( 
		array(
			"Invoice" 				=> array(
				"InvoiceNumber" 	=> $order_details->post_content
			),
			"Account" 				=> array(
				"Code" 				=> $BankCode
			),
			"Date" 					=> $xero_date,
			"Amount"				=> $order_details->post_mime_type
		)
	);
	$transaction_id 			= $order->get_transaction_id();
	if($transaction_id ==""){
		$paymentXero	=	$xero->Payments($new_payment);
		if(isset($paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'])){
			$errD=$paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError']['Message'].". Please Create your bank account on xero and update bank code in xeroom setting's bank code.";
			$wpdb->insert($xeroDebugTable, 
				array(
					'order_id'  			=> intval($order_id),
					'debug'   				=> sanitize_text_field($errD),
					'created_date' 			=> $xeroTime
				)
			);
		}else if(isset($paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0])){
			$errD	=	array();
			$errD	=	$invoiceCreated['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][0];
			for($e=0; $e<count($errD); $e++){
				$errorMessage	=	$paymentXero['Elements']['DataContractBase']['ValidationErrors']['ValidationError'][$e]['Message'];
				$wpdb->insert($xeroDebugTable, 
					array(
						'order_id'  			=> intval($order_id),
						'debug'   				=> sanitize_text_field($errorMessage),
						'created_date' 			=> $xeroTime
					)
				);
			}
		}
	}
}